﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HeuristicLab.MainForm {
  public class MainFormManager {
    private MainFormManager() {
      MainFormManager.mainform = null;
    }

    private static IMainForm mainform;
    public static void RegisterMainForm(IMainForm mainform) {
      if (MainFormManager.mainform == null)
        MainFormManager.mainform = mainform;
      else
        throw new ArgumentException("A mainform was already associated with the mainform manager.");
    }

    public static IMainForm Instance {
      get { return mainform; }
    }

    public static T GetInstance<T>() where T : IMainForm {
      return (T)mainform;
    }
  }
}
